<%
Class DBFactory
    Private m_Provider
    Private m_oCn
    Private m_oCm
    Private m_CntReq
    
    Private Sub Class_Initialize
        Debug.DWrite "DBFactory Private Sub Class_Initialize<blockquote>"
        Set Connection = Nothing
        Set Command = Nothing
        CountRequest = 0
        m_Provider = null
    End Sub

    Private Sub Class_Terminate
        Set Command = Nothing
        If Connection.State = 1 Then Connection.Close()
        Set Connection = Nothing
        Debug.DWrite "Nb of requests For this DB instance = " & CountRequest
        Debug.DWrite "</blockquote>DBFactory Private Sub Class_Terminate"
    End Sub
    
    '******** PROPERTIES

    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me) & "<span style=""color: green"">***Release***</span>"
    End Property
    
    Public Property Let Provider(value)
        m_Provider = value
    End Property
    Private Property Get Provider
        If IsNull(m_Provider) Then
            m_Provider = Application("ConnectionString")
        End If
        Provider = m_Provider
    End Property

    Private Property Set Connection(value)
        Set m_oCn = value
    End Property
    Private Property Get Connection
        If m_oCn is nothing Then
            Set m_oCn = Server.CreateObject("ADODB.Connection")
            m_oCn.ConnectionTimeout = 30
            m_oCn.ConnectionString = Provider
            m_oCn.Open()
        End If
        Set Connection = m_oCn
    End Property

    Private Property Set Command(value)
        Set m_oCm = value
    End Property
    Private Property Get Command
        If m_oCm is nothing Then
            Set m_oCm = Server.CreateObject("ADODB.Command")
            m_oCm.ActiveConnection = Connection
        End If
        Set Command = m_oCm
    End Property

    Private Property Let CountRequest(value)
        m_CntReq = m_CntReq + value
    End Property
    Private Property Get CountRequest
        CountRequest = m_CntReq
    End Property
    
    '******** FONCTIONS / SUBS
    
    Public Function ExecuteQuery(s)
        Dim rs
        on error resume next
        
        Command.CommandText = s
        Set rs = Command.Execute()
            CountRequest = 1
            call Debug.DWrite(ucase(s))
            call Debug.RsToTable(rs)
            Set ExecuteQuery = rs
        Set rs = Nothing
        
        If Connection.Errors.Count > 0 then
            for each objErr in Connection.Errors 
                Session("BDErrors") = "<ul><li>Description:" & objErr.Description & "</li>" & _
                    "<li>HelpContext" & objErr.HelpContext & "</li>" & _
                    "<li>HelpFile" & objErr.HelpFile & "</li>" & _
                    "<li>NativeError" & objErr.NativeError & "</li>" & _
                    "<li>Number" & objErr.Number & "</li>" & _
                    "<li>Source" & objErr.Source & "</li>" & _
                    "<li>SQLState" & objErr.SQLState & "</li>" & _
                    "<ul>"
            next
            Response.Redirect("http://" & Request.ServerVariables("SERVER_NAME") & ":" & Request.ServerVariables("SERVER_PORT") & "/test/error.asp")
        End if
        err.Clear
        on error goto 0
    End Function

    Public Function GetRst(s)
        Set GetRst = ExecuteQuery(s)
    End Function

    Public Function GetRows(s)
        GetRows = ExecuteQuery(s).GetRows()
    End Function

    Public Sub RsToTable(rs, classname)
        If StrComp(lcase(typename(rs)), "recordset") = 0 Then
            Dim i
            response.Write("<table class=""" & classname & """>"  & vbcrlf)
            response.Write("<tr>" & vbcrlf)
            For i= 0 to rs.fields.count-1
                response.write ("<th>" & rs.fields(i).name & "&nbsp;</th>" & vbcrlf)
            Next 
            response.Write("</tr>" & vbcrlf)
            If not rs.eof Then
                Do while not rs.eof 
                    response.Write("<tr>" & vbcrlf)
                    For i= 0 to rs.fields.count-1 
                        response.write ("<td>" & rs.fields(i).value & "&nbsp;</td>" & vbcrlf)
                    Next 
                    response.Write("</tr>" & vbcrlf)
                    rs.movenext 
                loop
                rs.movefirst
            Else
                Response.Write("<tr><td colspan=""" & rs.fields.count & """>No records</td></tr>")
            End If
            response.Write("</table>" & vbcrlf)
        End If
    End Sub

    Public Sub SqlToTable(sql, classname)
        Call RsToTable(ExecuteQuery(sql), classname)
    End Sub

    Public Sub SqlToPagedTable(sql, classname, pageSize, pageNum)
        Dim rs
        Connection.CursorLocation = 3
        Set rs = ExecuteQuery(sql)
            rs.PageSize = pageSize
            Response.Write("TEST: " & rs.PageSize & " " & rs.PageCount)
            Call RsToTable(rs, classname)
            Response.Write(Pager(pageNum, rs.PageCount, rs.AbsolutePage, classname))
        Set rs = Nothing
        Connection.CursorLocation = 2
    End Sub

    Private Function Pager(PageNum, PageCount, AbsolutePage, classname)
        If PageCount > 0 then
            Dim html, i
            
            html = "<table class=""" & classname & """>" & vbcrlf & _
                "<tr><td><a href=""" & Request.ServerVariables("SCRIPT_NAME") & "?Direction=Prev&PageNum=" & PageNum - 1 & """><< Previous</a></td><td>"
            for i = 1 to PageCount
                html = html & " " & i & " "
            Next
            html = html & "</td><td><a href=""" & Request.ServerVariables("SCRIPT_NAME") & "?Direction=Prev&PageNum=" & PageNum + 1 & """>Next >></a></td></tr>" & _
                "</table>"
        Else
        
        End if
        Pager = html
    End Function

    Public Sub RsToDDListe(rs, classname, selectedvalue, id)
        if StrComp(lcase(typename(rs)), "recordset") = 0 Then
            Dim i
            i = 0
            If not rs.eof then
                response.Write("<select class=""" & classname & """ id=""" & id & """ name=""" & id & """>"  & vbcrlf)
                Do while not rs.eof
                    i = i + 1
                    if i mod 2 = 0 then
                        Response.Write("<option class=""odd"" ")
                    else
                        Response.Write("<option class=""even"" ")
                    end if
                    
                    If strcomp(selectedvalue, rs.fields(0).value) = 0 then
                        response.write ("value=""" & rs.fields(0).value & """ selected = ""selected"">" & rs.fields(1).value & "</option>" & vbcrlf)
                    Else
                        response.write ("value=""" & rs.fields(0).value & """>" & rs.fields(1).value & "</option>" & vbcrlf)
                    End if
                    rs.movenext 
                loop
                response.Write("</select>" & vbcrlf)
            End if
        End if
    End Sub
    
    Public Sub SqlToDDListe(sql, classname, selectedvalue, id)
        Call RsToDDListe(ExecuteQuery(sql), classname, selectedvalue, id)
    End Sub

    Public Sub RsToXls(rs, path)
        If StrComp(lcase(typename(rs)), "recordset") = 0 Then
            If not rs.eof Then
                Dim i, j, xlsname
                Dim objSpreadsheet
                rs.movefirst
                Set objSpreadsheet = Server.CreateObject("OWC11.Spreadsheet")
                    With objSpreadsheet
                        For i= 0 to rs.fields.count - 1
                            .Cells(1, i+1).Value = rs.fields(i).name
                        Next
                        j = 2
                        while not rs.eof 
                            For i= 0 to rs.fields.count-1 
                                .Cells(j, i+1).Value = rs.fields(i).value
                            Next
                            j = j + 1
                            rs.movenext 
                        wend
                        .ActiveSheet.Name = "Export"
                        .Export path, 0
                    End with
                Set objSpreadsheet = Nothing
            End If
        End If
    End sub

    Public Function RsToCsv(rs)
        Dim i, tmpString
        tmpString = null
        if not rs.eof then
            tmpString = null
            for i = 0 to rs.fields.count - 1
                tmpString = tmpString & rs.fields(i).name & ";"
            next
            tmpString = tmpString  & vbcrlf
            while not rs.eof 
                for i = 0 to rs.fields.count-1 
                    tmpString = tmpString & rs.fields(i).value & ";"
                next
                tmpString = tmpString  & vbcrlf
                rs.movenext 
            wend
        end if
        RsToCsv = tmpString
    End Function

    Public Function DbTxtIn(pString)
        DbTxtIn = Replace(Replace(Globals.DefaultValue(pString, ""), "'", "''"), "<br />", vbCrlf)
    End Function
    Public Function DbTxtOut(pString)
        DbTxtOut = Replace(Replace(Globals.DefaultValue(pString, ""), "''", "'"), vbCrlf, "<br />")
    End Function
    
    Public Function DbNumIn(pNum)
        DbNumIn = Globals.DefaultValue(pNum, 0)
    End Function
    Public Function DbNumOut(pNum)
        DbNumOut = Globals.DefaultValue(pNum, 0)
    End Function

    Public Function DbDateIn(pDate)
        DbDateIn = Globals.DefaultValue(pDate, 0)
    End Function
    Public Function DbDateOut(pDate)
        DbDateOut = Replace(Globals.DefaultValue(pDate, ""), vbCrlf, "<br />")
    End Function

End Class
%>
