<%

Class CEmail
    Private m_SMTP_IP
    Private cdoSendUsingMethod
    Private cdoSMTPServer
    Private cdoSMTPConnectionTimeout
    Private cdoSMTPAuthenticate
    Private cdoSendUserReplyEmailAddress
    
    Private Sub Class_Initialize
        m_SMTP_IP = "192.168.0.1"
        cdoSendUsingMethod = "http://schemas.microsoft.com/cdo/configuration/sendusing"
        cdoSMTPServer = "http://schemas.microsoft.com/cdo/configuration/smtpserver"
        cdoSMTPConnectionTimeout = "http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout"
        cdoSMTPAuthenticate = "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate"
        cdoSendUserReplyEmailAddress = "http://schemas.microsoft.com/cdo/configuration/senduserreplyemailaddress"
    End Sub
    
    Private Sub Class_Terminate
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me) & "<span style=""color: red"">***Debuging***</span>"
    End Property
    
    Public Property Let SMTP_IP(pIP)
        m_SMTP_IP = pIP
    End Property

    'envoi un mail format texte en CDONTS ou non en fonction de la version de IIS
    Public sub sendMail(sFrom, sTo, sSubject, sTexte)
        Dim oMail, objConfiguration, colFields
        If Request.ServerVariables("SERVER_SOFTWARE")="Microsoft-IIS/4.0" Then
            Set oMail=Server.CreateObject("CDONTS.NewMail")
            oMail.From="<" & sFrom & ">"
            oMail.To=sTo
            oMail.Subject=sSubject
            oMail.Body=sTexte
            oMail.Send
            Set oMail=nothing
        else
            sendMail2000 sFrom, sTo, sSubject, sTexte
        End If
    End sub

    Public sub sendMail2000(sFrom, sTo, sSubject, sTexte)
        Dim oMail, objConfiguration, colFields
        Set objConfiguration = Server.CreateObject("CDO.Configuration")
        Set colFields = objConfiguration.Fields
        colFields(cdoSMTPServer) = m_SMTP_IP
        colFields(cdoSendUsingMethod) = 2
        colFields(cdoSMTPConnectionTimeout) = 100
        colFields(cdoSMTPAuthenticate) = 0
        colFields(cdoSendUserReplyEmailAddress) = sFrom
        colFields.Update
        Set oMail = Server.CreateObject("CDO.Message")
        With oMail
            Set .Configuration = objConfiguration
            .To = sTo
            .From = "<" & sFrom & ">"
            .Subject = sSubject
            .TextBody = sTexte
            .Send
        End With
        Set oMail = Nothing
        Set colFields=nothing
        Set objConfiguration=nothing
    End sub 

    'envoi mail format texte avec une copie carbone
    Public sub sendMailCC(sFrom, sTo, sCC, sSubject, sTexte)
        Dim oMail, objConfiguration, colFields
        Set objConfiguration = Server.CreateObject("CDO.Configuration")
        Set colFields = objConfiguration.Fields
        colFields(cdoSMTPServer) = m_SMTP_IP
        colFields(cdoSendUsingMethod) = 2
        colFields(cdoSMTPConnectionTimeout) = 100
        colFields(cdoSMTPAuthenticate) = 0
        colFields(cdoSendUserReplyEmailAddress) = sFrom
        colFields.Update
        Set oMail = Server.CreateObject("CDO.Message")
        With oMail
            Set .Configuration = objConfiguration
            .To = sTo
            .cc = sCC
            .From = "<" & sFrom & ">"
            .Subject = sSubject
            .TextBody = sTexte
            .Send
        End With
        Set oMail = Nothing
        Set colFields=nothing
        Set objConfiguration=nothing
    End sub 

    'envoie mail format HTML
    Public sub sendMailHtml(sFrom, sTo, sSubject, sTexte)
        Dim oMail, objConfiguration, colFields
        Set objConfiguration = Server.CreateObject("CDO.Configuration")
        Set colFields = objConfiguration.Fields
        colFields(cdoSMTPServer) = m_SMTP_IP
        colFields(cdoSendUsingMethod) = 2
        colFields(cdoSMTPConnectionTimeout) = 100
        colFields(cdoSMTPAuthenticate) = 0
        colFields(cdoSendUserReplyEmailAddress) = sFrom
        colFields.Update
        Set oMail = Server.CreateObject("CDO.Message")
        If noBadMail(sTo, "") <> "" and noBadMail(sFrom, "") <> "" Then
            With oMail
                Set .Configuration = objConfiguration
                .To = sTo
                .From = "<" & sFrom & ">"
                .Subject = sSubject
                .HTMLBody = sTexte
                .Send
            End With
        End If
        Set oMail = Nothing
        Set colFields=nothing
        Set objConfiguration=nothing
    End sub 

    'envoie mail format HTML avec un NOM d'expditeur
    Public sub sendMailHtmlWithSenderName(sFromName, sFromMail, sTo, sSubject, sTexte)
        Dim oMail, objConfiguration, colFields
        Set objConfiguration = Server.CreateObject("CDO.Configuration")
        Set colFields = objConfiguration.Fields
        colFields(cdoSMTPServer) = m_SMTP_IP
        colFields(cdoSendUsingMethod) = 2
        colFields(cdoSMTPConnectionTimeout) = 100
        colFields(cdoSMTPAuthenticate) = 0
        colFields(cdoSendUserReplyEmailAddress) = sFromMail
        colFields.Update
        Set oMail = Server.CreateObject("CDO.Message")
        If noBadMail(sTo, "") <> "" and noBadMail(sFromMail, "") <> "" Then
            With oMail
                Set .Configuration = objConfiguration
                .To = sTo
                .From = sFromName & " <" & sFromMail & ">"
                .Subject = sSubject
                .HTMLBody = sTexte
                .Send
            End With
        End If
        Set oMail = Nothing
        Set colFields=nothing
        Set objConfiguration=nothing
    End sub 

    'on va tester la validit d'une adresse email (que les caractres autoriss)
    Public Function NoBadMail(pMail, pDefault)
        Dim numChar, isGoodMailAddress
        Dim TempAddress
        If pMail = "" Then pMail = pDefault End If
        TempAddress = LTrim(RTrim(pMail))
        'on vrifie la prsence de l'arobase et du point
        'en liminant des cas ineptes survenus
        isGoodMailAddress = (instr(TempAddress, "@") <> 0 and instr(TempAddress, ".") <> 0 and instr(TempAddress, "@@") = 0 and instr(TempAddress, "..") = 0 and containsDomain(TempAddress))
        'on vrifie chaque caractre (il faut boucler un tour de plus pour s'assurer de la vrification du dernier caractre)
        For numChar = 1 to len(TempAddress) + 1
            If isGoodMailAddress Then
                noBadMail =    TempAddress
                If numChar <= len(TempAddress) Then 
                    isGoodMailAddress = isGoodEmailCharacter(mid(TempAddress, numchar, 1))
                End If
            else
                'mauvais caractre trouv !
                noBadMail = pDefault
            End If
        Next 
    End Function

    Public Function IsGoodEmailCharacter(pChar)
        Dim authorizedChar, numChar
        isGoodEmailCharacter = False 
        authorizedChar = "azertyuiopmlkjhgfdsqwxcvbn0123456789-_@."
        For numchar = 1 to len(authorizedChar)
            If not isGoodEmailCharacter Then
                isGoodEmailCharacter = lCase(mid(authorizedChar, numChar, 1)) = lCase(DefaultValue(pChar, ""))
            End If
        Next
    End Function

    Public Function ContainsDomain(pMail)
        Dim pName, pDomain
        If inStr(pMail, "@") <> 0 Then
            pName = left(pMail, inStr(pMail, "@")-1)
            pDomain = right(pMail, len(pMail)-inStr(pMail, "@"))
            'response.write "#" & pName & "#" & pDomain & "<br>"
            containsDomain = not ( _
                len(pDomain) < 5 _
                or inStr(pDomain, ".") = 0 _
                or len(right(pDomain, len(pDomain)-instr(pDomain, "."))) < 2 )
        else
            'ne peut contenir un nom de domaine
            containsDomain = False
        End If
        'response.write containsDomain & "<br>"
    End Function

End Class

%>