<%
Class CEncryption
    Private m_Sha1
    
    Private Sub Class_Initialize
        Set m_Sha1 = Nothing
    End Sub
    
    Private Sub Class_Terminate
        Set m_Sha1 = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me) & "<span style=""color: green"">***Release***</span>"
    End Property
    
    Public Function ToHex(value)
        value = clng(value)
        ToHex = lcase(hex(value))
        Do While Len(ToHex) < 8
            ToHex = "0" & ToHex
        Loop
    End Function

    Public Function ToBin(value)
        Dim hexstr, i
        hexstr = tohex(value)
        ToBin = ""
        For i = 1 to Len(hexstr)
            Select Case Mid(hexstr, i, 1)
                Case "f", "F"
                    ToBin = ToBin & "1111"
                Case "e", "E"
                    ToBin = ToBin & "1110"
                Case "d", "D"
                    ToBin = ToBin & "1101"
                Case "c", "C"
                    ToBin = ToBin & "1100"
                Case "b", "B"
                    ToBin = ToBin & "1011"
                Case "a", "A"
                    ToBin = ToBin & "1010"
                Case "9"
                    ToBin = ToBin & "1001"
                Case "8"
                    ToBin = ToBin & "1000"
                Case "7"
                    ToBin = ToBin & "0111"
                Case "6"
                    ToBin = ToBin & "0110"
                Case "5"
                    ToBin = ToBin & "0101"
                Case "4"
                    ToBin = ToBin & "0100"
                Case "3"
                    ToBin = ToBin & "0011"
                Case "2"
                    ToBin = ToBin & "0010"
                Case "1"
                    ToBin = ToBin & "0001"
                Case else
                    ToBin = ToBin & "0000"
            End Select
        Next
    End Function

    Public Function Bin2Dec(binstr)
        Dim flip, i
        flip = False
        Bin2Dec = clng(0)
        If left(binstr,1) = "0" Then
            For i = 1 to Len(binstr)
                If Mid(binstr,33-i,1)="1" Then
                    Bin2Dec = Bin2Dec + (2^(i-1))
                End If
            Next
        else
            For i = 1 to Len(binstr)
                If flip Then
                    If Mid(binstr,33-i,1)="0" Then
                        Bin2Dec = Bin2Dec - (2^(i-1))
                    End If
                else
                    If Mid(binstr,33-i,1)="1" Then
                        Bin2Dec = Bin2Dec - (2^(i-1))
                        flip = true
                    End If
                End If
            Next
        End If
    End Function  

    Public Function rShift(value, count)
        Dim binstr
        If count >= 32 Then
            binstr = ""
        elseif count > 0 Then
            binstr = left(ToBin(value), 32-count)
        else
            binstr = ToBin(value)
        End If
        Do While Len(binstr) < 32
            binstr = "0" + binstr
        Loop
        rShift = Bin2Dec(binstr)  
    End Function

    Public Function lShift(value, count)
        Dim binstr
        If count >= 32 Then
            binstr = ""
        elseif count > 0 Then
            binstr = right(ToBin(value), 32-count)
        else
            binstr = ToBin(value)
        End If
        Do While Len(binstr) < 32
            binstr = binstr + "0"
        Loop
        lShift = Bin2Dec(binstr)
    End Function

    Public Function Rol(value, count)
        Rol = lShift(value,count) or rShift(value,32-count)
    End Function

    Public Function add32(a, b)
        Dim bina, binb, total, result, carry, i
        bina = ToBin(a)
        binb = ToBin(b)
        result = ""
        carry = "0"
        For i = 1 to 32
            total = 0
            If Mid(bina,33-i,1)="1" Then total = total + 1
            If Mid(binb,33-i,1)="1" Then total = total + 1
            If carry="1" Then total = total + 1
            Select Case total
                Case 3
                    carry = "1"
                    result = "1" + result
                Case 2
                    carry = "1"
                    result = "0" + result
                Case 1
                    carry = "0"
                    result = "1" + result
                Case else
                    carry = "0"
                    result = "0" + result
            End Select
        Next
        add32 = Bin2Dec(result)    
    End Function

    Public Function f(b, c, d, t)
        If t < 20 Then
            f = (b and c) or ((not b) and d)
        elseif t < 40 Then
            f = b xor c xor d
        elseif t < 60 Then
            f = (b and c) or (b and d) or (c and d)
        else
            f = b xor c xor d
        End If
    End Function

    Public Function k(t)
        If t < 20 Then
            k = clng(1518500249)
        elseif t < 40 Then
            k = clng(1859775393)
        elseif t < 60 Then
            k = clng(-1894007588)
        else
            k = clng(-899497514)
        End If
    End Function

    Public Function Pad(message)
        Dim l, n, i
        l = Len(message)
        n = (((l+8) \ 64) + 1)*16
        Redim m(n-1)
        For i = 0 to n-1
            m(i) = clng(0)
        Next
        For i = 0 to l-1
            m(i\4) = m(i\4) or lShift(asc(Mid(message,i+1,1)),(24-(i mod 4)*8))
        Next
        m(l\4) = m(l\4) or lShift(clng(128),(24-(l mod 4)*8))
        m(n-1) = l*8
        Pad = m
    End Function

    Public Function Sha1(message)
        Dim h0, h1, h2, h3, h4
        Dim a, b, c, d, e, temp, block
        Dim l, m, n, t
        Dim w(79)

        l = Len(message)
        n = (((l+8) \ 64) + 1)*16
        m = Pad(message)

        h0 = clng(1732584193)
        h1 = clng(-271733879)
        h2 = clng(-1732584194)
        h3 = clng(271733878)
        h4 = clng(-1009589776)

        For block = 0 to n-1 step 16
            a = h0
            b = h1
            c = h2
            d = h3
            e = h4
            For t = 0 to 79
                If t < 16 Then
                    w(t) = m(block + t)
                else
                    w(t) = Rol(w(t-3) xor w(t-8) xor w(t-14) xor w(t-16),1)
                End If
                temp = add32(Rol(a,5),add32(f(b,c,d,t),add32(e,add32(w(t),k(t)))))
                e = d
                d = c
                c = Rol(b,30)
                b = a
                a = temp
            Next
            h0 = add32(h0, a)
            h1 = add32(h1, b)
            h2 = add32(h2, c)
            h3 = add32(h3, d)
            h4 = add32(h4, e)
        Next
        Sha1 = tohex(h0)+tohex(h1)+tohex(h2)+tohex(h3)+tohex(h4)
    End Function
End Class
%>