<%
Class CFile
    Private m_File

    Private Sub Class_Initialize
        Set m_File = Nothing
    End Sub
    
    Private Sub Class_Terminate
        Set m_File = Nothing
    End Sub
    
    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me) & "<span style=""color: green"">***Release***</span>"
    End Property
    
    Public Property Set File(value)
        Set m_File = value
    End Property
    Public Property Get File
        If m_File is Nothing Then
            Set m_File = Server.CreateObject("Scripting.FileSystemObject")
        End If
        Set File = m_File
    End Property
    
    ' ForReading = 1, ForWriting = 2, ForAppending = 8
    Public Sub StringToFile(str, path, forwhat)
        Dim f
        forwhat = Globals.DefaultValue(forwhat, 2)
        set f = File.OpenTextFile(path, forwhat, true)
            f.WriteLine(str)
            f.Close
        set f = Nothing
    End Sub
    
    Public Sub DownLoad(path)
        Dim Arr
        Dim objStream
        Const adTypeBinary = 1
        
        If File.FileExists(path) Then
            Arr = split(path,"\")
            
            Response.Buffer = True
            Response.Clear
            
            Set objStream = Server.CreateObject("ADODB.Stream")
                objStream.Open
                    objStream.Type = adTypeBinary
                    objStream.LoadFromFile path
                    Response.AddHeader "Content-Disposition", "attachment; filename= " & Arr(ubound(Arr))
                    Response.Charset = "UTF-8"
                    Response.ContentType = "application/octet-stream"
                    Response.BinaryWrite objStream.Read
                    Response.Flush
                objStream.Close
            Set objStream = Nothing
        End If
    End sub

    Public Sub DownloadFromString(s, fn)
        Dim ContentType
        
        ContentType = lcase(Mid(fn, InStr(fn,"."), len(fn) - InStr(fn,".") + 1))
        
        Select Case ContentType
            Case ".txt"
                ContentType = "application/text"
            Case ".doc", ".docx"
                ContentType = "application/msword"
            Case ".xls", ".xlsx", ".csv"
                ContentType = "application/vnd.ms-excel"
            Case Else
                'Handle All Other Files
                ContentType = "application/octet-stream"
        End Select
        Response.Clear
        Response.ContentType = ContentType
        Response.CharSet = "iso-8859-1"
        Response.AddHeader "Content-Disposition", "filename=" & fn
        Response.BinaryWrite s
        Response.Flush
    End Sub
    
    Public Function GetFileExtension(pPath)
        GetFileExtension = File.GetExtensionName(pPath)
    End Function

    ' conversion de la taille d'un ficher de l'octet en Ko
    '+-------------------------------------------------------
    Public Function GetSizeAndUnit(pSize, pWithUnit)
        Dim isMega, isKilo, isOctet
        isMega = (Round(pSize/(1000 * 1024)) <> 0)
        isKilo = (not isMega and (Round(pSize/1024) <> 0))
        isOctet = (not isMega and not isKilo)
        If isMega Then
            getSizeAndUnit = Round(pSize/(1000 * 1024))
            If pWithUnit Then getSizeAndUnit = getSizeAndUnit & " Mo" End If
        elseif isKilo Then
            getSizeAndUnit = Round(pSize/1024)
            If pWithUnit Then getSizeAndUnit = getSizeAndUnit & " Ko" End If
        elseif isOctet Then
            getSizeAndUnit = pSize
            If pWithUnit Then getSizeAndUnit = getSizeAndUnit & " octet" End If
        else
            getSizeAndUnit = pSize
        End If
    End Function
    
End Class
%>