<%
Class HttpContext
    Private m_HttpContext
    Private m_Arr_Keys
    Private m_Arr_Names
    Private m_IsPostBack

    Private Sub Class_Initialize
        Set Session("BDErrors") = Nothing
        Set m_HttpContext = Server.CreateObject("Scripting.Dictionary")
        GrabServerVariables
        GrabApplication
        GrabSession
        GrabCookies
        GrabForm
        GrabQueryString
        GrabScriptError
        GrabSqlError
        SetArrays
    End Sub

    Private Sub Class_Terminate
        Set m_HttpContext = Nothing
    End Sub

    Public Default Property Get DefaultProperty
        DefaultProperty = typename(Me)
    End Property
        
    ' Nombre d'lments dans le dictionnaire
    Public Property Get Count
        Count = m_HttpContext.Count
    End Property

    ' Rfrence vers la collection Form
    Public Property Get Form
        Set Form = Request.Form
    End Property

    ' Rfrence vers la collection QueryString
    Public Property Get QueryString
        Set QueryString = Request.QueryString
    End Property

    ' Permet de savoir si un formulaire a t soumis
    Public Property Get IsPostBack
        Select case lcase(Me.ItemByKey("REQUEST_METHOD"))
            Case "post"
                If Me.ItemByKey("CONTENT_LENGTH") > 0 Then
                    m_IsPostBack = true
                else
                    m_IsPostBack = False
                End If
            Case "get"
                If Me.QueryString.Count > 0 Then
                    m_IsPostBack = true
                Else
                    m_IsPostBack = False
                End If
            Case else
                m_IsPostBack = False
        End Select
        IsPostBack = m_IsPostBack
    End Property

    ' Permet de renvoyer la valeur d'un lment du dictionnaire en fonction de sa clef (son nom)
    Public Property Get ItemByKey(key)
        If m_HttpContext.Exists(key) Then
            ItemByKey = m_HttpContext.Item(key)
        Else
            ItemByKey = null
        End If
    End Property    

    ' Permet de renvoyer la valeur d'un lment en fonction de son index
    Public Property Get ItemByIndex(i)
        on error resume next
        if i <= Ubound(m_Arr_Names) then
            ItemByIndex = m_Arr_Names(i)
        else
            ItemByIndex = "Index " & i & " en dehors de la plage"
        end if
        on error goto 0
    End Property

    ' Permet de renvoyer la clef d'un lment en fonction de son index
    Public Property Get KeyByIndex(i)
        KeyByIndex = m_Arr_Keys(i)
    End Property    

    ' Affiche le contenu du dictionnaire
    Public Sub ToTable
        Dim i 
        Response.Write "<table border=""1"">" & vbcrlf
        For i = 0 to Me.Count - 1
            if len(Me.ItemByIndex(i)) > 0 then
                Response.Write "<tr><td>" & Me.KeyByIndex(i) & "</td><td>" & Me.ItemByIndex(i) & "</td></tr>" & vbcrlf
            end if
        Next
        Response.Write "</table>" & vbcrlf
    End Sub

    ' Cr un fichier XML au chemin spcifi (chemin + nom du fichier)
    Public Sub ToXml(path)
        Dim objDom, objRoot, objRow, objField, objFieldValue, objPI, i
        Set objDom = server.CreateObject("Microsoft.XMLDOM")
            objDom.preserveWhiteSpace = True
            Set objRoot = objDom.createElement("root")
                objDom.appendChild objRoot
                For i = 1 to Me.Count - 1
                    Set objRow = objDom.CreateElement("item")
                    Set objField = objDom.createElement(Me.KeyByIndex(i))
                        objField.Text = Me.ItemByIndex(i)
                        objRow.appendChild objField
                    Set objField = Nothing
                    objRoot.appendChild objRow
                    Set objRow = Nothing
                Next
                Set objPI = objDom.createProcessingInstruction("xml", "version='1.0' encoding='iso-8859-1'")
                    objDom.insertBefore objPI, objDom.childNodes(0)
                Set objPI = Nothing
            Set objRoot = Nothing
            objDom.Save path
        Set objDom = Nothing
    End Sub


    ' Rcupre les variables serveur
    Private Sub GrabServerVariables
        Dim i
        For i = 1 to Request.ServerVariables.Count
            m_HttpContext.Add Request.ServerVariables.Key(i), Request.ServerVariables.Item(i)
        Next
    End Sub

    ' Rcupre les variables d'application
    Private Sub GrabApplication
        Dim i
        For i = 1 to Application.Contents.Count
            m_HttpContext.Add Application.Contents.Key(i), Application.Contents.Item(i)
        Next
    End Sub

    ' Rcupre les variables de session
    Private Sub GrabSession
        Dim i
        For i = 1 to Session.Contents.Count
            m_HttpContext.Add Session.Contents.Key(i), Session.Contents.Item(i)
        Next
    End Sub

    ' Rcupre les cookies
    Private Sub GrabCookies
        Dim i
        For i = 1 to Request.Cookies.Count
            m_HttpContext.Add Request.Cookies.Key(i), Request.Cookies.Item(i)
        Next
    End Sub

    ' Rcupre les variables formulaire
    Private Sub GrabForm
        Dim i
        If lcase(Request.ServerVariables("CONTENT_TYPE")) <> "multipart/form-data" Then
            If Request.Form.Count > 0 Then
                For i = 1 to Request.Form.Count
                    m_HttpContext.Add Request.Form.Key(i), Request.Form.Item(i)
                Next
            End If
        End If
    End Sub

    ' Rcupre les variables de l'url
    Private Sub GrabQueryString
        Dim i
        If Request.QueryString.Count > 0 Then
            For i = 1 to Request.QueryString.Count
                m_HttpContext.Add Request.QueryString.Key(i), Request.QueryString.Item(i)
            Next
        End If
    End Sub
    
    ' Rcupre la dernire erreur
    Private Sub GrabScriptError
        m_HttpContext.Add "Server.GetLastError.ASPCode", Server.GetLastError.ASPCode
        m_HttpContext.Add "Server.GetLastError.ASPDescription", Server.GetLastError.ASPDescription
        m_HttpContext.Add "Server.GetLastError.Category", Server.GetLastError.Category
        m_HttpContext.Add "Server.GetLastError.Column", Server.GetLastError.Column
        m_HttpContext.Add "Server.GetLastError.Description", Server.GetLastError.Description
        m_HttpContext.Add "Server.GetLastError.File", Server.GetLastError.File
        m_HttpContext.Add "Server.GetLastError.Line", Server.GetLastError.Line
        m_HttpContext.Add "Server.GetLastError.Number", Server.GetLastError.Number
        m_HttpContext.Add "Server.GetLastError.Source", Server.GetLastError.Source
    End Sub
    
    ' Rcupre la dernire erreur SQL
    Private Sub GrabSqlError
        m_HttpContext.Add "Session(""BDErrors"")", Session("BDErrors")
    End Sub
    
    ' Assigne les clefs et les valeurs dans deux tableaux
    Private Sub SetArrays
        m_Arr_Keys = m_HttpContext.Keys
        m_Arr_Names = m_HttpContext.Items
    End Sub
End Class
%>
